require "spec_helper"
require "#{TOOLCHAIN_ROOT}/attributes"

require "time"

class ModelData
  include Toolchain::Attributes

  attribute :string, String
  attribute :string_default, String, ""
  attribute :integer, Integer
  attribute :integer_default, Integer, 0
  attribute :float, Float
  attribute :float_default, Float, 0.0
  attribute :array, Array
  attribute :array_default, Array, []
  attribute :hash, Hash
  attribute :hash_default, Hash, {}
  attribute :boolean, Boolean
  attribute :boolean_default, Boolean, false
  attribute :time, Time
  attribute :time_default, Time, -> { Time.now }
  attribute :date, Date
  attribute :date_default, Date, -> { Date.today }
  attribute :date_time, DateTime
  attribute :date_time_default, DateTime, -> { DateTime.now }
end

RSpec.configure do |config|

  config.before do
    Toolchain::Attributes::Configuration.configure do |config|
      config.hash_transformation = :symbolize_keys
      config.include_nil_in_attributes = false
    end
  end
end
