require_relative "base_helper"

describe Toolchain::Attributes, "Boolean" do

  let(:model) { ModelData.new }

  it "should set the boolean to true" do
    expect { model.boolean = true }.
      to change { model.boolean }.from(nil).to(true)
  end

  it "should accept '1' as true" do
    expect { model.boolean = "1" }.
      to change { model.boolean }.from(nil).to(true)
  end

  it "should accept 1 as true" do
    expect { model.boolean = 1 }.
      to change { model.boolean }.from(nil).to(true)
  end

  it "should accept '0' as false" do
    expect { model.boolean = '0' }.
      to change { model.boolean }.from(nil).to(false)
  end
  it "should accept 0 as false" do
    expect { model.boolean = 0 }.
      to change { model.boolean }.from(nil).to(false)
  end

  it "should raise exception unless type is TrueClass or FalseClass" do
    expect { model.boolean = "Example" }.
      to raise_error(
        Toolchain::Attributes::Errors::TypeMismatch,
        "ModelData#boolean expected [TrueClass, FalseClass] type, " +
        "but received String (Example).")
  end
end
