require_relative "base_helper"

describe Toolchain::Attributes::Configuration do

  let(:config) { Toolchain::Attributes::Configuration }

  it "should configure for symbol" do
    config.hash_transformation.should == :symbolize_keys
  end

  it "should configure for string" do
    expect { config.hash_transformation = :stringify_keys }.
      to change { config.hash_transformation }.
      from(:symbolize_keys).to(:stringify_keys)
  end

  it "should raise an exception on invalid type" do
    expect { config.configure { |c| c.hash_transformation = :foo } }.
      to raise_error(
        Toolchain::Attributes::Errors::InvalidHashTransformation,
        "valid types: :symbolize_keys, :stringify_keys."
    )
  end

  it "should configure to omit nil values in attributes" do
    config.include_nil_in_attributes.should == false
  end

  it "should configure to omit nil values in attributes" do
    expect { config.configure { |c| c.include_nil_in_attributes = true } }.
      to change { config.include_nil_in_attributes }.from(false).to(true)
  end
end
