require_relative "base_helper"

describe Toolchain::Attributes, "Hash" do

  let(:model) { ModelData.new }

  it "should symbolize keys" do
    model.hash = {
      "foo" => "bar",
      baz: true,
      "deep" => {
        nested: "hash",
        "become" => "symbolized",
        once: {
          "more" => :is_enough
        }
      }
    }

    model.hash.should == {
      foo: "bar",
      baz: true,
      deep: {
        nested: "hash",
        become: "symbolized",
        once: {
          more: :is_enough
        }
      }
    }
  end

  it "should stringify keys" do
    Toolchain::Attributes::Configuration.
      hash_transformation = :stringify_keys

    model.hash = {
      "foo" => "bar",
      baz: true,
      "deep" => {
        nested: "hash",
        "become" => "symbolized",
        once: {
          "more" => :is_enough
        }
      }
    }

    model.hash.should == {
      "foo" => "bar",
      "baz" => true,
      "deep" => {
        "nested" => "hash",
        "become" => "symbolized",
        "once" => {
          "more" => :is_enough
        }
      }
    }
  end
end
