require_relative "base_helper"

describe Toolchain::Validations, "Conditional" do

  class PersonConditionalIfTrue
    include Toolchain::Validations
    validates :name, presence: true, if: ->(i){ i.new }
    attr_accessor :name
    def new; true end
  end

  it "should validate" do
    person = PersonConditionalIfTrue.new
    person.should_not be_valid
  end

  class PersonConditionalIfFalse
    include Toolchain::Validations
    validates :name, presence: true, if: ->(i){ i.new }
    attr_accessor :name
    def new; false end
  end

  it "should not validate" do
    person = PersonConditionalIfFalse.new
    person.should be_valid
  end

  class PersonConditionalUnlessTrue
    include Toolchain::Validations
    validates :name, presence: true, unless: ->(i){ i.new }
    attr_accessor :name
    def new; true end
  end

  it "should not validate" do
    person = PersonConditionalUnlessTrue.new
    person.should be_valid
  end

  class PersonConditionalUnlessFalse
    include Toolchain::Validations
    validates :name, presence: true, unless: ->(i){ i.new }
    attr_accessor :name
    def new; false end
  end

  it "should validate" do
    person = PersonConditionalUnlessFalse.new
    person.should_not be_valid
  end
end
