require_relative "base_helper"

describe Toolchain::Validations, "Custom Validations" do

  class UserCustomValidation
    include Toolchain::Validations
    attr_accessor :name
    attr_accessor :error_out
    validate :name_validation

    def name_validation
      errors.add(:name, "custom validation error") if error_out
    end
  end

  it "should be valid" do
    UserCustomValidation.new.should be_valid
  end

  it "should be invalid" do
    user = UserCustomValidation.new
    user.error_out = true
    user.should_not be_valid
    user.errors.should == { name: ["custom validation error"] }
  end
end
