require_relative "base_helper"

describe Toolchain::Validations, "IncludeValidations" do

  UserExternalValidations = Proc.new do
    validates :name, presence: true
  end

  class UserIncludedValidations
    include Toolchain::Validations
    include_validations UserExternalValidations
    attr_accessor :name
  end

  it "should include validations" do
    user = UserIncludedValidations.new
    user.should_not be_valid
    user.errors[:name].should == ["can't be blank"]
  end
end
