require_relative "base_helper"

describe Toolchain::Validations, "Inheritence" do

  class UserInheritingValidations
    include Toolchain::Validations
    attr_reader :name
    validates :name, presence: true
    validate :name_validation

    private

    def name_validation
      errors.add(:name, "custom name error")
    end
  end

  class UserInheritedValidations < UserInheritingValidations
  end

  it "should be invalid" do
    user = UserInheritedValidations.new
    user.should_not be_valid
    user.errors.should == { name: ["can't be blank", "custom name error"] }
  end
end
