require_relative "base_helper"

describe Toolchain::Validations, "Multiple Validations" do

  class UserMultipleValidator
    include Toolchain::Validations
    attr_accessor :email
    validates :email,
      presence: { message: "provide an email address" },
      email: { message: "email address isn't valid" }
  end

  it "should use multiple validators" do
    user = UserMultipleValidator.new
    user.should_not be_valid
    user.errors[:email].should ==
      ["provide an email address", "email address isn't valid"]
  end
end
