require_relative "../base_helper"

describe Toolchain::Validations::Validators::Acceptance do

  class UserAcceptance
    include Toolchain::Validations
    attr_accessor :terms
    validates :terms, acceptance: true
  end

  it "should be valid if 1" do
    user = UserAcceptance.new
    user.terms = 1
    user.should be_valid
  end

  it "should be valid if '1'" do
    user = UserAcceptance.new
    user.terms = "1"
    user.should be_valid
  end

  it "should be valid if true" do
    user = UserAcceptance.new
    user.terms = true
    user.should be_valid
  end

  it "should be invalid" do
    user = UserAcceptance.new
    user.terms = nil
    user.should_not be_valid
    user.errors[:terms].should == ["must be accepted"]
  end

  class UserAcceptanceMessage
    include Toolchain::Validations
    attr_accessor :terms
    validates :terms, acceptance: { message: "acceptance required" }
  end

  it "should be invalid" do
    user = UserAcceptanceMessage.new
    user.terms = nil
    user.should_not be_valid
    user.errors[:terms].should == ["acceptance required"]
  end
end
