require_relative "../base_helper"

describe Toolchain::Validations::Validators::Presence do

  class UserPresence
    include Toolchain::Validations
    attr_accessor :name
    validates :name, presence: true
  end

  it "should be valid" do
    user = UserPresence.new
    user.name = "Michael"
    user.should be_valid
  end

  it "is invalid if blank" do
    user = UserPresence.new
    user.should_not be_valid
    user.errors[:name].should == ["can't be blank"]
  end

  class UserPresenceMessage
    include Toolchain::Validations
    attr_accessor :name
    validates :name, presence: { message: "is required" }
  end

  it "should have a custom error message" do
    user = UserPresenceMessage.new
    user.should_not be_valid
    user.errors[:name].should == ["is required"]
  end
end
